#include "nana/gui.hpp"
#include "memorycard.hpp"
#include "widget/block_grid.hpp"
#include "make_nana_animation.hpp"
#include <iostream>
#include <fstream>

#include <vector>
#include <iostream>

namespace {
	const constexpr int g_def_icon_size = 48;
	const constexpr int g_def_icon_fps = 3;
} //unnamed namespace

int main() {
	nana::form frm;

	const MemoryCard mc(std::ifstream("/home/michele/dev/code/cpp/memoserv/michele_epsxe000.mcr", std::ios::binary));

#if !defined(NDEBUG)
	//grid1.bgcolor(nana::colors::azure);
#endif

	duck::widget::BlockGrid grid1{frm, 3, true};
	duck::widget::BlockGrid grid2{frm, 3, true};

	for (int z = 0; z < 15; ++z) {
		grid1.emplace_back(duck::make_nana_animation(mc[z], g_def_icon_size, g_def_icon_size, g_def_icon_fps));
		grid2.emplace_back(duck::make_nana_animation(mc[z], g_def_icon_size, g_def_icon_size, g_def_icon_fps));
	}

	std::cout << "Hello world\n";
	frm.div("vert<>< <weight=5%><grid1><weight=5%><grid2> ><>");
	frm["grid1"] << grid1;
	frm["grid2"] << grid2;
	frm.collocate();
	frm.show();

	//const MemoryCard mc(std::ifstream("/home/michele/emu/psx/WipEout 3 - Special Edition (Europe) (En,Fr,De,Es,It).srm", std::ios::binary));
	//MemoryCard mc(std::ifstream("/home/michele/emu/psx/Rapid Racer (Europe) (En,Fr,De,Es,It).srm", std::ios::binary));


	nana::exec();
	return 0;
}
